diff --git a/sys/netinet6/ip6_input.c b/sys/netinet6/ip6_input.c
index 95a3fd0fb6..b98a6c30fa 100644
--- a/sys/netinet6/ip6_input.c
+++ b/sys/netinet6/ip6_input.c
@@ -64,7 +64,6 @@
 #include "opt_ip6fw.h"
 #include "opt_inet.h"
 #include "opt_inet6.h"
-#include "opt_ipsec.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -108,19 +107,6 @@
 #include <netinet6/in6_ifattach.h>
 #include <netinet6/nd6.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#ifdef INET6
-#include <netinet6/ipsec6.h>
-#endif
-#endif
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/ipsec6.h>
-#define	IPSEC
-#endif /* FAST_IPSEC */
-
 #include <net/ip6fw/ip6_fw.h>
 
 #include <netinet6/ip6protosw.h>
@@ -227,17 +213,6 @@ ip6_input(netmsg_t msg)
 	struct in6_addr odst;
 	int srcrt = 0;
 
-#ifdef IPSEC
-	/*
-	 * should the inner packet be considered authentic?
-	 * see comment in ah4_input().
-	 */
-	if (m) {
-		m->m_flags &= ~M_AUTHIPHDR;
-		m->m_flags &= ~M_AUTHIPDGM;
-	}
-#endif
-
 	/*
 	 * make sure we don't have onion peering information into m_aux.
 	 */
@@ -758,17 +733,6 @@ ip6_input(netmsg_t msg)
 		}
 
 		sw6 = &inet6sw[ip6_protox[nxt]];
-#ifdef IPSEC
-		/*
-		 * enforce IPsec policy checking if we are seeing last header.
-		 * note that we do not visit this with protocols with pcb layer
-		 * code - like udp/tcp/raw ip.
-		 */
-		if ((sw6->pr_flags & PR_LASTHDR) && ipsec6_in_reject(m, NULL)) {
-			ipsec6stat.in_polvio++;
-			goto bad;
-		}
-#endif
 		/*
 		 * If this is a terminal header forward to the port, otherwise
 		 * process synchronously for more headers.
diff --git a/sys/netinet6/ip6_output.c b/sys/netinet6/ip6_output.c
index 83e725e73f..62eff5632c 100644
--- a/sys/netinet6/ip6_output.c
+++ b/sys/netinet6/ip6_output.c
@@ -64,7 +64,6 @@
 #include "opt_ip6fw.h"
 #include "opt_inet.h"
 #include "opt_inet6.h"
-#include "opt_ipsec.h"
 
 #include <sys/param.h>
 #include <sys/malloc.h>
@@ -95,20 +94,6 @@
 #include <netinet6/nd6.h>
 #include <netinet6/ip6protosw.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#ifdef INET6
-#include <netinet6/ipsec6.h>
-#endif
-#include <netproto/key/key.h>
-#endif /* IPSEC */
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/ipsec6.h>
-#include <netproto/ipsec/key.h>
-#endif
-
 #include <net/ip6fw/ip6_fw.h>
 
 #include <net/net_osdep.h>
@@ -174,20 +159,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 	struct in6_addr finaldst;
 	struct route_in6 *ro_pmtu = NULL;
 	boolean_t hdrsplit = FALSE;
-	boolean_t needipsec = FALSE;
-#ifdef IPSEC
-	boolean_t needipsectun = FALSE;
-	struct secpolicy *sp = NULL;
-	struct socket *so = inp ? inp->inp_socket : NULL;
-
-	ip6 = mtod(m, struct ip6_hdr *);
-#endif
-#ifdef FAST_IPSEC
-	boolean_t needipsectun = FALSE;
-	struct secpolicy *sp = NULL;
-
-	ip6 = mtod(m, struct ip6_hdr *);
-#endif
 
 	bzero(&exthdrs, sizeof exthdrs);
 
@@ -202,91 +173,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 			goto freehdrs;
 	}
 
-#ifdef IPSEC
-	/* get a security policy for this packet */
-	if (so == NULL)
-		sp = ipsec6_getpolicybyaddr(m, IPSEC_DIR_OUTBOUND, 0, &error);
-	else
-		sp = ipsec6_getpolicybysock(m, IPSEC_DIR_OUTBOUND, so, &error);
-
-	if (sp == NULL) {
-		ipsec6stat.out_inval++;
-		goto freehdrs;
-	}
-
-	error = 0;
-
-	/* check policy */
-	switch (sp->policy) {
-	case IPSEC_POLICY_DISCARD:
-		/*
-		 * This packet is just discarded.
-		 */
-		ipsec6stat.out_polvio++;
-		goto freehdrs;
-
-	case IPSEC_POLICY_BYPASS:
-	case IPSEC_POLICY_NONE:
-		/* no need to do IPsec. */
-		needipsec = FALSE;
-		break;
-
-	case IPSEC_POLICY_IPSEC:
-		if (sp->req == NULL) {
-			error = key_spdacquire(sp);	/* acquire a policy */
-			goto freehdrs;
-		}
-		needipsec = TRUE;
-		break;
-
-	case IPSEC_POLICY_ENTRUST:
-	default:
-		kprintf("ip6_output: Invalid policy found. %d\n", sp->policy);
-	}
-#endif /* IPSEC */
-#ifdef FAST_IPSEC
-	/* get a security policy for this packet */
-	if (inp == NULL)
-		sp = ipsec_getpolicybyaddr(m, IPSEC_DIR_OUTBOUND, 0, &error);
-	else
-		sp = ipsec_getpolicybysock(m, IPSEC_DIR_OUTBOUND, inp, &error);
-
-	if (sp == NULL) {
-		newipsecstat.ips_out_inval++;
-		goto freehdrs;
-	}
-
-	error = 0;
-
-	/* check policy */
-	switch (sp->policy) {
-	case IPSEC_POLICY_DISCARD:
-		/*
-		 * This packet is just discarded.
-		 */
-		newipsecstat.ips_out_polvio++;
-		goto freehdrs;
-
-	case IPSEC_POLICY_BYPASS:
-	case IPSEC_POLICY_NONE:
-		/* no need to do IPsec. */
-		needipsec = FALSE;
-		break;
-
-	case IPSEC_POLICY_IPSEC:
-		if (sp->req == NULL) {
-			error = key_spdacquire(sp);	/* acquire a policy */
-			goto freehdrs;
-		}
-		needipsec = TRUE;
-		break;
-
-	case IPSEC_POLICY_ENTRUST:
-	default:
-		kprintf("ip6_output: Invalid policy found. %d\n", sp->policy);
-	}
-#endif /* FAST_IPSEC */
-
 	/*
 	 * Calculate the total length of the extension header chain.
 	 * Keep the length of the unfragmentable part for fragmentation.
@@ -301,10 +187,10 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 	optlen += m_lengthm(exthdrs.ip6e_dest2, NULL);
 
 	/*
-	 * If we need IPsec, or there is at least one extension header,
+	 * If there is at least one extension header,
 	 * separate IP6 header from the payload.
 	 */
-	if ((needipsec || optlen) && !hdrsplit) {
+	if (optlen && !hdrsplit) {
 		exthdrs.ip6e_ip6 = ip6_splithdr(m);
 		if (exthdrs.ip6e_ip6 == NULL) {
 			error = ENOBUFS;
@@ -355,8 +241,7 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 	mprev = m;
 
 	/*
-	 * we treat dest2 specially.  this makes IPsec processing
-	 * much easier.  the goal here is to make mprev point the
+	 * we treat dest2 specially. the goal here is to make mprev point the
 	 * mbuf prior to dest2.
 	 *
 	 * result: IPv6 dest2 payload
@@ -397,58 +282,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 	MAKE_CHAIN(exthdrs.ip6e_dest1, mprev, nexthdrp, IPPROTO_DSTOPTS);
 	MAKE_CHAIN(exthdrs.ip6e_rthdr, mprev, nexthdrp, IPPROTO_ROUTING);
 
-#if defined(IPSEC) || defined(FAST_IPSEC)
-	if (needipsec) {
-		struct ipsec_output_state state;
-		int segleft_org = 0;
-		struct ip6_rthdr *rh = NULL;
-
-		/*
-		 * pointers after IPsec headers are not valid any more.
-		 * other pointers need a great care too.
-		 * (IPsec routines should not mangle mbufs prior to AH/ESP)
-		 */
-		exthdrs.ip6e_dest2 = NULL;
-
-		if (exthdrs.ip6e_rthdr) {
-			rh = mtod(exthdrs.ip6e_rthdr, struct ip6_rthdr *);
-			segleft_org = rh->ip6r_segleft;
-			rh->ip6r_segleft = 0;
-		}
-
-		bzero(&state, sizeof state);
-		state.m = m;
-		error = ipsec6_output_trans(&state, nexthdrp, mprev, sp, flags,
-					    &needipsectun);
-		m = state.m;
-		if (error) {
-			/* mbuf is already reclaimed in ipsec6_output_trans. */
-			m = NULL;
-			switch (error) {
-			case EHOSTUNREACH:
-			case ENETUNREACH:
-			case EMSGSIZE:
-			case ENOBUFS:
-			case ENOMEM:
-				break;
-			default:
-				kprintf("ip6_output (ipsec): error code %d\n",
-				       error);
-				/* FALLTHROUGH */
-			case ENOENT:
-				/* don't show these error codes to the user */
-				error = 0;
-				break;
-			}
-			goto bad;
-		}
-		if (exthdrs.ip6e_rthdr) {
-			/* ah6_output doesn't modify mbuf chain */
-			rh->ip6r_segleft = segleft_org;
-		}
-	}
-#endif
-
 	/*
 	 * If there is a routing header, replace the destination address field
 	 * with the first hop of the routing header.
@@ -509,57 +342,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 		dst->sin6_len = sizeof(struct sockaddr_in6);
 		dst->sin6_addr = ip6->ip6_dst;
 	}
-#if defined(IPSEC) || defined(FAST_IPSEC)
-	if (needipsec && needipsectun) {
-		struct ipsec_output_state state;
-
-		/*
-		 * All the extension headers will become inaccessible
-		 * (since they can be encrypted).
-		 * Don't panic, we need no more updates to extension headers
-		 * on inner IPv6 packet (since they are now encapsulated).
-		 *
-		 * IPv6 [ESP|AH] IPv6 [extension headers] payload
-		 */
-		bzero(&exthdrs, sizeof(exthdrs));
-		exthdrs.ip6e_ip6 = m;
-
-		bzero(&state, sizeof(state));
-		state.m = m;
-		state.ro = (struct route *)ro;
-		state.dst = (struct sockaddr *)dst;
-
-		error = ipsec6_output_tunnel(&state, sp, flags);
-
-		m = state.m;
-		ro = (struct route_in6 *)state.ro;
-		dst = (struct sockaddr_in6 *)state.dst;
-		if (error) {
-			/* mbuf is already reclaimed in ipsec6_output_tunnel. */
-			m0 = m = NULL;
-			m = NULL;
-			switch (error) {
-			case EHOSTUNREACH:
-			case ENETUNREACH:
-			case EMSGSIZE:
-			case ENOBUFS:
-			case ENOMEM:
-				break;
-			default:
-				kprintf("ip6_output (ipsec): error code %d\n", error);
-				/* FALLTHROUGH */
-			case ENOENT:
-				/* don't show these error codes to the user */
-				error = 0;
-				break;
-			}
-			goto bad;
-		}
-
-		exthdrs.ip6e_ip6 = m;
-	}
-#endif
-
 	if (!IN6_IS_ADDR_MULTICAST(&ip6->ip6_dst)) {
 		/* Unicast */
 
@@ -946,10 +728,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 			IFA_STAT_INC(&ia6->ia_ifa, opackets, 1);
 			IFA_STAT_INC(&ia6->ia_ifa, obytes, m->m_pkthdr.len);
 		}
-#ifdef IPSEC
-		/* clean ipsec history once it goes out of the node */
-		ipsec_delaux(m);
-#endif
 		error = nd6_output(ifp, origifp, m, dst, ro->ro_rt);
 		goto done;
 	} 
@@ -1080,10 +858,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
  				IFA_STAT_INC(&ia->ia_ifa, obytes,
 				    m->m_pkthdr.len);
  			}
-#ifdef IPSEC
-			/* clean ipsec history once it goes out of the node */
-			ipsec_delaux(m);
-#endif
 			error = nd6_output(ifp, origifp, m, dst, ro->ro_rt);
 		} else
 			m_freem(m);
@@ -1099,15 +873,6 @@ ip6_output(struct mbuf *m0, struct ip6_pktopts *opt, struct route_in6 *ro,
 		RTFREE(ro_pmtu->ro_rt);
 	}
 
-#ifdef IPSEC
-	if (sp != NULL)
-		key_freesp(sp);
-#endif
-#ifdef FAST_IPSEC
-	if (sp != NULL)
-		KEY_FREESP(&sp);
-#endif
-
 	return (error);
 
 freehdrs:
@@ -1749,27 +1514,6 @@ do { \
 				}
 				break;
 
-#if defined(IPSEC) || defined(FAST_IPSEC)
-			case IPV6_IPSEC_POLICY:
-			    {
-				caddr_t req = NULL;
-				size_t len = 0;
-				struct mbuf *m;
-
-				if ((error = soopt_getm(sopt, &m)) != 0) /* XXX */
-					break;
-				soopt_to_mbuf(sopt, m);		/* XXX */
-				if (m) {
-					req = mtod(m, caddr_t);
-					len = m->m_len;
-				}
-				error = ipsec6_set_policy(in6p, optname, req,
-							  len, privileged);
-				m_freem(m);
-			    }
-				break;
-#endif /* KAME IPSEC */
-
 			case IPV6_FW_ADD:
 			case IPV6_FW_DEL:
 			case IPV6_FW_FLUSH:
@@ -1996,31 +1740,6 @@ do { \
 			    }
 				break;
 
-#if defined(IPSEC) || defined(FAST_IPSEC)
-			case IPV6_IPSEC_POLICY:
-			  {
-				caddr_t req = NULL;
-				size_t len = 0;
-				struct mbuf *m = NULL;
-				struct mbuf **mp = &m;
-
-				error = soopt_getm(sopt, &m); /* XXX */
-				if (error != 0)
-					break;
-				soopt_to_mbuf(sopt, m); /* XXX */
-				if (m) {
-					req = mtod(m, caddr_t);
-					len = m->m_len;
-				}
-				error = ipsec6_get_policy(in6p, req, len, mp);
-				if (error == 0)
-					error = soopt_from_mbuf(sopt, m);/*XXX*/
-				if (error == 0 && m != NULL)
-					m_freem(m);
-				break;
-			  }
-#endif /* KAME IPSEC */
-
 			case IPV6_FW_GET:
 			  {
 				struct mbuf *m;
diff --git a/sys/netinet6/nd6_nbr.c b/sys/netinet6/nd6_nbr.c
index 1778709cf7..4dbf67b98a 100644
--- a/sys/netinet6/nd6_nbr.c
+++ b/sys/netinet6/nd6_nbr.c
@@ -32,7 +32,6 @@
 
 #include "opt_inet.h"
 #include "opt_inet6.h"
-#include "opt_ipsec.h"
 #include "opt_carp.h"
 
 #include <sys/param.h>
@@ -67,13 +66,6 @@
 #include <netinet6/nd6.h>
 #include <netinet/icmp6.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#ifdef INET6
-#include <netinet6/ipsec6.h>
-#endif
-#endif
-
 #include <net/net_osdep.h>
 
 #ifdef CARP
diff --git a/sys/netinet6/raw_ip6.c b/sys/netinet6/raw_ip6.c
index c890589abb..0572a172f5 100644
--- a/sys/netinet6/raw_ip6.c
+++ b/sys/netinet6/raw_ip6.c
@@ -60,7 +60,6 @@
  *	@(#)raw_ip.c	8.2 (Berkeley) 1/4/94
  */
 
-#include "opt_ipsec.h"
 #include "opt_inet6.h"
 
 #include <sys/param.h>
@@ -99,16 +98,6 @@
 #endif
 #include <netinet6/raw_ip6.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#include <netinet6/ipsec6.h>
-#endif /*IPSEC*/
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/ipsec6.h>
-#endif /* FAST_IPSEC */
-
 #include <machine/stdarg.h>
 
 #define	satosin6(sa)	((struct sockaddr_in6 *)(sa))
@@ -168,25 +157,6 @@ rip6_input(struct mbuf **mp, int *offp, int proto)
 		if (last) {
 			struct mbuf *n = m_copy(m, 0, (int)M_COPYALL);
 
-#ifdef IPSEC
-			/*
-			 * Check AH/ESP integrity.
-			 */
-			if (n && ipsec6_in_reject_so(n, last->inp_socket)) {
-				m_freem(n);
-				ipsec6stat.in_polvio++;
-				/* do not inject data into pcb */
-			} else
-#endif /*IPSEC*/
-#ifdef FAST_IPSEC
-			/*
-			 * Check AH/ESP integrity.
-			 */
-			if (n && ipsec6_in_reject(n, last)) {
-				m_freem(n);
-				/* do not inject data into pcb */
-			} else
-#endif /*FAST_IPSEC*/
 			if (n) {
 				struct socket *so;
 
@@ -214,27 +184,6 @@ rip6_input(struct mbuf **mp, int *offp, int proto)
 		}
 		last = in6p;
 	}
-#ifdef IPSEC
-	/*
-	 * Check AH/ESP integrity.
-	 */
-	if (last && ipsec6_in_reject_so(m, last->inp_socket)) {
-		m_freem(m);
-		ipsec6stat.in_polvio++;
-		ip6stat.ip6s_delivered--;
-		/* do not inject data into pcb */
-	} else
-#endif /*IPSEC*/
-#ifdef FAST_IPSEC
-	/*
-	 * Check AH/ESP integrity.
-	 */
-	if (last && ipsec6_in_reject(m, last)) {
-		m_freem(m);
-		ip6stat.ip6s_delivered--;
-		/* do not inject data into pcb */
-	} else
-#endif /*FAST_IPSEC*/
 	if (last) {
 		struct socket *so;
 
diff --git a/sys/netinet6/udp6_output.c b/sys/netinet6/udp6_output.c
index 40b76e1253..ff591542be 100644
--- a/sys/netinet6/udp6_output.c
+++ b/sys/netinet6/udp6_output.c
@@ -61,7 +61,6 @@
  *	@(#)udp_var.h	8.1 (Berkeley) 6/10/93
  */
 
-#include "opt_ipsec.h"
 #include "opt_inet.h"
 #include "opt_inet6.h"
 
@@ -98,13 +97,6 @@
 #include <netinet/icmp6.h>
 #include <netinet6/ip6protosw.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#ifdef INET6
-#include <netinet6/ipsec6.h>
-#endif
-#endif /* IPSEC */
-
 #include <net/net_osdep.h>
 
 /*
diff --git a/sys/netinet6/udp6_usrreq.c b/sys/netinet6/udp6_usrreq.c
index 229b8d534c..3b1aee7472 100644
--- a/sys/netinet6/udp6_usrreq.c
+++ b/sys/netinet6/udp6_usrreq.c
@@ -63,7 +63,6 @@
 
 #include "opt_inet.h"
 #include "opt_inet6.h"
-#include "opt_ipsec.h"
 
 #include <sys/param.h>
 #include <sys/kernel.h>
@@ -103,16 +102,6 @@
 #include <netinet6/udp6_var.h>
 #include <netinet6/ip6protosw.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#include <netinet6/ipsec6.h>
-#endif /* IPSEC */
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/ipsec6.h>
-#endif /* FAST_IPSEC */
-
 /*
  * UDP protocol inplementation.
  * Per RFC 768, August, 1980.
@@ -216,7 +205,6 @@ udp6_input(struct mbuf **mp, int *offp, int proto)
 		udp_in6.sin6_port = uh->uh_sport;
 		/*
 		 * KAME note: traditionally we dropped udpiphdr from mbuf here.
-		 * We need udphdr for IPsec processing so we do that later.
 		 */
 
 		/*
@@ -257,23 +245,6 @@ udp6_input(struct mbuf **mp, int *offp, int proto)
 			if (last != NULL) {
 				struct mbuf *n;
 
-#ifdef IPSEC
-				/*
-				 * Check AH/ESP integrity.
-				 */
-				if (ipsec6_in_reject_so(m, last->inp_socket))
-					ipsec6stat.in_polvio++;
-					/* do not inject data into pcb */
-				else
-#endif /* IPSEC */
-#ifdef FAST_IPSEC
-				/*
-				 * Check AH/ESP integrity.
-				 */
-				if (ipsec6_in_reject(m, last))
-					;
-				else
-#endif /* FAST_IPSEC */
 				if ((n = m_copy(m, 0, M_COPYALL)) != NULL) {
 					/*
 					 * KAME NOTE: do not
@@ -331,23 +302,6 @@ udp6_input(struct mbuf **mp, int *offp, int proto)
 			udp_stat.udps_noportmcast++;
 			goto bad;
 		}
-#ifdef IPSEC
-		/*
-		 * Check AH/ESP integrity.
-		 */
-		if (ipsec6_in_reject_so(m, last->inp_socket)) {
-			ipsec6stat.in_polvio++;
-			goto bad;
-		}
-#endif /* IPSEC */
-#ifdef FAST_IPSEC
-		/*
-		 * Check AH/ESP integrity.
-		 */
-		if (ipsec6_in_reject(m, last)) {
-			goto bad;
-		}
-#endif /* FAST_IPSEC */
 		if (last->in6p_flags & IN6P_CONTROLOPTS
 		    || last->in6p_socket->so_options & SO_TIMESTAMP)
 			ip6_savecontrol(last, &opts, ip6, m);
@@ -390,23 +344,6 @@ udp6_input(struct mbuf **mp, int *offp, int proto)
 		icmp6_error(m, ICMP6_DST_UNREACH, ICMP6_DST_UNREACH_NOPORT, 0);
 		return IPPROTO_DONE;
 	}
-#ifdef IPSEC
-	/*
-	 * Check AH/ESP integrity.
-	 */
-	if (ipsec6_in_reject_so(m, in6p->in6p_socket)) {
-		ipsec6stat.in_polvio++;
-		goto bad;
-	}
-#endif /* IPSEC */
-#ifdef FAST_IPSEC
-	/*
-	 * Check AH/ESP integrity.
-	 */
-	if (ipsec6_in_reject(m, in6p)) {
-		goto bad;
-	}
-#endif /* FAST_IPSEC */
 
 	/*
 	 * Construct sockaddr format source address.
diff --git a/sys/platform/pc64/conf/files b/sys/platform/pc64/conf/files
index b53f576ed5..0a14fa7a44 100644
--- a/sys/platform/pc64/conf/files
+++ b/sys/platform/pc64/conf/files
@@ -41,8 +41,6 @@ emulation/ndis/subr_u4bd.c	optional	ndisapi pci
 emulation/ndis/winx64_wrap.S	optional	ndisapi pci
 
 # XXX use assembler versions of bf_enc
-crypto/blowfish/bf_enc.c		optional	ipsec ipsec_esp
-crypto/des/des_enc.c			optional	ipsec ipsec_esp
 crypto/blowfish/bf_enc.c		optional	crypto
 crypto/des/des_enc.c			optional	crypto
 crypto/des/des_ecb.c			optional	crypto
diff --git a/sys/platform/vkernel64/conf/files b/sys/platform/vkernel64/conf/files
index 2b85426d8a..46e5b2199d 100644
--- a/sys/platform/vkernel64/conf/files
+++ b/sys/platform/vkernel64/conf/files
@@ -1,8 +1,6 @@
 # This file tells config what files go into building a kernel,
 # files marked standard are always included.
 #
-crypto/blowfish/bf_enc.c		optional	ipsec ipsec_esp
-crypto/des/des_enc.c			optional	ipsec ipsec_esp
 crypto/blowfish/bf_enc.c		optional	crypto
 crypto/des/des_enc.c			optional	crypto
 crypto/des/des_ecb.c			optional	crypto
diff --git a/sys/sys/param.h b/sys/sys/param.h
index 5b8edd1a86..7f89e7d104 100644
--- a/sys/sys/param.h
+++ b/sys/sys/param.h
@@ -173,9 +173,10 @@
  * 500300 - 5.3 development
  * 500301 - rename some public UFS constants
  * 500302 - move IOCTLTRIM to a better header and rename it to DAIOCTRIM
+ * 500303 - remove IPSEC/FAST_IPSEC
  */
 #undef __DragonFly_version
-#define __DragonFly_version 500302	/* propagated to newvers */
+#define __DragonFly_version 500303	/* propagated to newvers */
 
 #include <sys/_null.h>
 
diff --git a/tools/tools/crypto/Makefile b/tools/tools/crypto/Makefile
index 75cd7991d8..5af648474c 100644
--- a/tools/tools/crypto/Makefile
+++ b/tools/tools/crypto/Makefile
@@ -26,7 +26,7 @@
 #
 
 ALL=	cryptotest cryptokeytest cryptostats \
-	ubsecstats hifnstats ipsecstats
+	ubsecstats hifnstats
 BINDIR=	/usr/local/bin
 PRIVATELIB_LDFLAGS?= -rpath /lib/priv:/usr/lib/priv -L /usr/lib/priv
 
@@ -54,10 +54,6 @@ hifnstats: hifnstats.c
 #safestats: safestats.c
 #	${CC} -o safestats safestats.c
 #
-# program to print statistics kept by fast ipsec
-ipsecstats: ipsecstats.c
-	${CC} -o ipsecstats ipsecstats.c
-
 clean:
 	rm -f ${ALL} core a.out
 
diff --git a/usr.bin/kdump/mkioctls b/usr.bin/kdump/mkioctls
index 120adfa11c..992410546f 100644
--- a/usr.bin/kdump/mkioctls
+++ b/usr.bin/kdump/mkioctls
@@ -23,7 +23,7 @@ LC_ALL=C; export LC_ALL
 ioctl_includes=`
 	cd $1
 	find -s * -name '*.h' -follow |
-		egrep -v '^(cam/)|^(compat/)|^(fs/)|^(isofs/)|^(mfs/)|^(msdosfs/)|^(netipsec/)|^(netkey/)|^(netsmb/)|^(nfs/)|^(ntfs/)|^(pccard/)|^(ufs/)' |
+		egrep -v '^(cam/)|^(compat/)|^(fs/)|^(isofs/)|^(mfs/)|^(msdosfs/)|^(netkey/)|^(netsmb/)|^(nfs/)|^(ntfs/)|^(pccard/)|^(ufs/)' |
 		xargs egrep -l \
 '^#[ 	]*define[ 	]+[A-Za-z_][A-Za-z0-9_]*[ 	]+_IO[^a-z0-9_]' |
 		awk '{printf("#include <%s>\\\\n", $1)}'
diff --git a/usr.bin/netstat/Makefile b/usr.bin/netstat/Makefile
index ebc03f1a1d..4633b299b1 100644
--- a/usr.bin/netstat/Makefile
+++ b/usr.bin/netstat/Makefile
@@ -3,8 +3,7 @@
 
 PROG=	netstat
 SRCS=	if.c inet.c inet6.c main.c mbuf.c mroute.c route.c \
-	unix.c netgraph.c mroute6.c ipsec.c
-CFLAGS+=-DIPSEC
+	unix.c netgraph.c mroute6.c
 CFLAGS+=-DINET6
 NO_STRICT_ALIASING=
 
diff --git a/usr.bin/netstat/main.c b/usr.bin/netstat/main.c
index 0d33e85450..90d8fbfeae 100644
--- a/usr.bin/netstat/main.c
+++ b/usr.bin/netstat/main.c
@@ -106,37 +106,33 @@ static struct nlist nl[] = {
 	{ .n_name = "_ip6stat" },
 #define N_ICMP6STAT	24
 	{ .n_name = "_icmp6stat" },
-#define N_IPSECSTAT	25
-	{ .n_name = "_ipsecstat" },
-#define N_IPSEC6STAT	26
-	{ .n_name = "_ipsec6stat" },
-#define N_PIM6STAT	27
+#define N_PIM6STAT	25
 	{ .n_name = "_pim6stat" },
-#define N_MRT6PROTO	28
+#define N_MRT6PROTO	26
 	{ .n_name = "_ip6_mrtproto" },
-#define N_MRT6STAT	29
+#define N_MRT6STAT	27
 	{ .n_name = "_mrt6stat" },
-#define N_MF6CTABLE	30
+#define N_MF6CTABLE	28
 	{ .n_name = "_mf6ctable" },
-#define N_MIF6TABLE	31
+#define N_MIF6TABLE	29
 	{ .n_name = "_mif6table" },
-#define N_PFKEYSTAT	32
+#define N_PFKEYSTAT	30
 	{ .n_name = "_pfkeystat" },
-#define N_MBSTAT	33
+#define N_MBSTAT	31
 	{ .n_name = "_mbstat" },
-#define N_MBTYPES	34
+#define N_MBTYPES	32
 	{ .n_name = "_mbtypes" },
-#define N_NMBCLUSTERS	35
+#define N_NMBCLUSTERS	33
 	{ .n_name = "_nmbclusters" },
-#define N_NMBUFS	36
+#define N_NMBUFS	34
 	{ .n_name = "_nmbufs" },
-#define	N_RTTRASH	37
+#define	N_RTTRASH	35
 	{ .n_name = "_rttrash" },
-#define	N_NCPUS		38
+#define	N_NCPUS		36
 	{ .n_name = "_ncpus" },
-#define	N_CARPSTAT	39
+#define	N_CARPSTAT	37
 	{ .n_name = "_carpstats" },
-#define N_NMBJCLUSTERS	40
+#define N_NMBJCLUSTERS	38
 	{ .n_name = "_nmbjclusters" },
 	{ .n_name = NULL },
 };
@@ -165,10 +161,6 @@ struct protox {
 	  icmp_stats,	NULL,		"icmp",	IPPROTO_ICMP },
 	{ -1,		-1,		1,	protopr,
 	  igmp_stats,	NULL,		"igmp",	IPPROTO_IGMP },
-#ifdef IPSEC
-	{ -1,		N_IPSECSTAT,	1,	0,
-	  ipsec_stats,	NULL,		"ipsec",	0},
-#endif
         { -1,           N_CARPSTAT,     1,      0,
           carp_stats,   NULL,           "carp",         0},
 	{ -1,		-1,		0,	0,
@@ -185,10 +177,6 @@ struct protox ip6protox[] = {
 	  ip6_stats,	ip6_ifstats,	"ip6",	IPPROTO_RAW },
 	{ -1,		N_ICMP6STAT,	1,	protopr,
 	  icmp6_stats,	icmp6_ifstats,	"icmp6",IPPROTO_ICMPV6 },
-#ifdef IPSEC
-	{ -1,		N_IPSEC6STAT,	1,	0,
-	  ipsec_stats,	NULL,		"ipsec6",0 },
-#endif
 #ifdef notyet
 	{ -1,		N_PIM6STAT,	1,	0,
 	  pim6_stats,	NULL,		"pim6",	0 },
@@ -202,15 +190,6 @@ struct protox ip6protox[] = {
 };
 #endif /*INET6*/
 
-#ifdef IPSEC
-struct protox pfkeyprotox[] = {
-	{ -1,		N_PFKEYSTAT,	1,	0,
-	  pfkey_stats,	NULL,		"pfkey", 0 },
-	{ -1,		-1,		0,	0,
-	  0,		NULL,		0,	0 }
-};
-#endif
-
 struct protox netgraphprotox[] = {
 	{ N_NGSOCKS,	-1,		1,	netgraphprotopr,
 	  NULL,		NULL,		"ctrl",	0 },
@@ -224,9 +203,6 @@ struct protox *protoprotox[] = {
 					 protox,
 #ifdef INET6
 					 ip6protox,
-#endif
-#ifdef IPSEC
-					 pfkeyprotox,
 #endif
 					 NULL };
 
@@ -504,11 +480,6 @@ main(int argc, char **argv)
 		for (tp = ip6protox; tp->pr_name; tp++)
 			printproto(tp, tp->pr_name, nl[N_NCPUS].n_value);
 #endif /*INET6*/
-#ifdef IPSEC
-	if (af == PF_KEY || af == AF_UNSPEC)
-		for (tp = pfkeyprotox; tp->pr_name; tp++)
-			printproto(tp, tp->pr_name, nl[N_NCPUS].n_value);
-#endif /*IPSEC*/
 	if (af == AF_NETGRAPH || af == AF_UNSPEC)
 		for (tp = netgraphprotox; tp->pr_name; tp++)
 			printproto(tp, tp->pr_name, nl[N_NCPUS].n_value);
diff --git a/usr.bin/netstat/netstat.h b/usr.bin/netstat/netstat.h
index 80aa468d68..4f4650f372 100644
--- a/usr.bin/netstat/netstat.h
+++ b/usr.bin/netstat/netstat.h
@@ -70,9 +70,6 @@ void	icmp_stats (u_long, const char *, int);
 void	igmp_stats (u_long, const char *, int);
 void	pim_stats (u_long, const char *, int);
 void   carp_stats (u_long, const char *, int);
-#ifdef IPSEC
-void	ipsec_stats (u_long, const char *, int);
-#endif
 
 #ifdef INET6
 void	ip6_stats (u_long, const char *, int);
@@ -90,10 +87,6 @@ char *routename6 (struct sockaddr_in6 *);
 const char *netname6 (struct sockaddr_in6 *, struct in6_addr *);
 #endif /*INET6*/
 
-#ifdef IPSEC
-void	pfkey_stats (u_long, const char *, int);
-#endif
-
 void	mbpr (u_long, u_long, u_long, u_long, u_long, u_long);
 
 void	hostpr (u_long, u_long);
diff --git a/usr.bin/telnet/Makefile b/usr.bin/telnet/Makefile
index 1d5e9d1307..b82424a00f 100644
--- a/usr.bin/telnet/Makefile
+++ b/usr.bin/telnet/Makefile
@@ -21,10 +21,6 @@ LDADD=		-lprivate_ncurses ${LIBTELNET}
 CFLAGS+=	-I${_SHLIBDIRPREFIX}/usr/include/priv/ncurses
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
 
-CFLAGS+=	-DIPSEC
-DPADD+=		${LIBIPSEC}
-LDADD+=		-lipsec
-
 CFLAGS+=	-DENCRYPTION -DAUTHENTICATION
 DPADD+=		${LIBCRYPTO} ${LIBCRYPT} ${LIBPAM}
 LDADD+=		-lprivate_crypto -lcrypt ${MINUSLPAM}
diff --git a/usr.bin/telnet/commands.c b/usr.bin/telnet/commands.c
index 967eeb0ccd..a41bfc74f5 100644
--- a/usr.bin/telnet/commands.c
+++ b/usr.bin/telnet/commands.c
@@ -2104,34 +2104,6 @@ sockaddr_ntop(struct sockaddr *sa)
     return addrbuf;
 }
 
-#if defined(IPSEC) && defined(IPSEC_POLICY_IPSEC)
-static int
-setpolicy(int lnet, struct addrinfo *res, char *policy)
-{
-	char *buf;
-	int level;
-	int optname;
-
-	if (policy == NULL)
-		return 0;
-
-	buf = ipsec_set_policy(policy, strlen(policy));
-	if (buf == NULL) {
-		printf("%s\n", ipsec_strerror());
-		return -1;
-	}
-	level = res->ai_family == AF_INET ? IPPROTO_IP : IPPROTO_IPV6;
-	optname = res->ai_family == AF_INET ? IP_IPSEC_POLICY : IPV6_IPSEC_POLICY;
-	if (setsockopt(lnet, level, optname, buf, ipsec_get_policylen(buf)) < 0){
-		perror("setsockopt");
-		return -1;
-	}
-
-	free(buf);
-	return 0;
-}
-#endif
-
 #ifdef INET6
 /*
  * When an Address Family related error happend, check if retry with
@@ -2419,16 +2391,6 @@ tn(int argc, char *argv[])
 		goto fail;
 	    }
 	}
-#if defined(IPSEC) && defined(IPSEC_POLICY_IPSEC)
-	if (setpolicy(net, res, ipsec_policy_in) < 0) {
-		(void) NetClose(net);
-		goto fail;
-	}
-	if (setpolicy(net, res, ipsec_policy_out) < 0) {
-		(void) NetClose(net);
-		goto fail;
-	}
-#endif
 
 	if (connect(net, res->ai_addr, res->ai_addrlen) < 0) {
 	    struct addrinfo *next;
diff --git a/usr.bin/telnet/externs.h b/usr.bin/telnet/externs.h
index 3aad36131b..03bfab5c39 100644
--- a/usr.bin/telnet/externs.h
+++ b/usr.bin/telnet/externs.h
@@ -67,14 +67,6 @@ typedef unsigned char cc_t;
 
 #include <string.h>
 
-#if defined(IPSEC)
-#include <netinet6/ipsec.h>
-#if defined(IPSEC_POLICY_IPSEC)
-extern char *ipsec_policy_in;
-extern char *ipsec_policy_out;
-#endif
-#endif
-
 #ifndef	_POSIX_VDISABLE
 # ifdef sun
 #  include <sys/param.h>	/* pick up VDISABLE definition, mayby */
diff --git a/usr.bin/telnet/main.c b/usr.bin/telnet/main.c
index fca22383e1..cbccbe2192 100644
--- a/usr.bin/telnet/main.c
+++ b/usr.bin/telnet/main.c
@@ -56,11 +56,6 @@
 #define FORWARD
 #endif
 
-#if defined(IPSEC) && defined(IPSEC_POLICY_IPSEC)
-char *ipsec_policy_in = NULL;
-char *ipsec_policy_out = NULL;
-#endif
-
 int family = AF_UNSPEC;
 
 /*
@@ -91,9 +86,6 @@ usage(void)
 	    "\n\t[-e char] [-l user] [-n tracefile] ",
 #endif
 	    "[-r] [-s src_addr] [-u] ",
-#if defined(IPSEC) && defined(IPSEC_POLICY_IPSEC)
-	    "[-P policy] "
-#endif
 #ifdef	ENCRYPTION
 	    "[-y] [host-name [port]]"
 #else	/* ENCRYPTION */
@@ -140,15 +132,7 @@ main(int argc, char *argv[])
 	decrypt_auto(1);
 #endif
 
-#if defined(IPSEC) && defined(IPSEC_POLICY_IPSEC)
-#define IPSECOPT	"P:"
-#else
-#define IPSECOPT
-#endif
-	while ((ch = getopt(argc, argv,
-			    "468EKLNS:X:acde:fFk:l:n:rs:t:uxy" IPSECOPT)) != -1)
-#undef IPSECOPT
-	{
+	while ((ch = getopt(argc, argv, "468EKLNS:X:acde:fFk:l:n:rs:t:uxy")) != -1) {
 		switch(ch) {
 		case '4':
 			family = AF_INET;
@@ -308,16 +292,6 @@ main(int argc, char *argv[])
 								prompt);
 #endif	/* ENCRYPTION */
 			break;
-#if defined(IPSEC) && defined(IPSEC_POLICY_IPSEC)
-		case 'P':
-			if (!strncmp("in", optarg, 2))
-				ipsec_policy_in = strdup(optarg);
-			else if (!strncmp("out", optarg, 3))
-				ipsec_policy_out = strdup(optarg);
-			else
-				usage();
-			break;
-#endif
 		case '?':
 		default:
 			usage();
diff --git a/usr.sbin/Makefile b/usr.sbin/Makefile
index fb5f6ec31a..d211b48365 100644
--- a/usr.sbin/Makefile
+++ b/usr.sbin/Makefile
@@ -111,7 +111,6 @@ SUBDIR= 802_11 \
 	sdpd \
 	sensorsd \
 	service \
-	setkey \
 	sshd \
 	sshlockout \
 	sliplogin \
diff --git a/usr.sbin/inetd/Makefile b/usr.sbin/inetd/Makefile
index 077425602b..779a30b769 100644
--- a/usr.sbin/inetd/Makefile
+++ b/usr.sbin/inetd/Makefile
@@ -1,18 +1,15 @@
 #	@(#)Makefile	8.1 (Berkeley) 6/6/93
 # $FreeBSD: src/usr.sbin/inetd/Makefile,v 1.18.2.4 2001/12/19 04:49:11 dd Exp $
-# $DragonFly: src/usr.sbin/inetd/Makefile,v 1.4 2008/05/23 23:40:59 swildner Exp $
 
 PROG=	inetd
 SRCS=	inetd.c builtins.c
 MAN=	inetd.8
 MLINKS=	inetd.8 inetd.conf.5
 
-CFLAGS+= -DLOGIN_CAP
+CFLAGS+=-DINET6 -DLOGIN_CAP
 #CFLAGS+= -DSANITY_CHECK
 
 DPADD+=	${LIBUTIL} ${LIBWRAP}
 LDADD+=	-lutil -lwrap
-CFLAGS+=-DINET6 -DIPSEC
-DPADD+=	${LIBIPSEC}
-LDADD+=	-lipsec
+
 .include <bsd.prog.mk>
